package lcsb.mapviewer;

import java.awt.geom.Point2D;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.Rule;

import lcsb.mapviewer.common.tests.TestUtils;
import lcsb.mapviewer.common.tests.UnitTestFailedWatcher;
import lcsb.mapviewer.model.map.species.GenericProtein;
import lcsb.mapviewer.model.map.species.field.ModificationState;
import lcsb.mapviewer.model.map.species.field.Residue;
import lcsb.mapviewer.model.map.species.field.StructuralState;

public class ModelTestFunctions extends TestUtils {

  protected static Logger logger = LogManager.getLogger();

  private static int elementCounter = 0;

  @Rule
  public UnitTestFailedWatcher unitTestFailedWatcher = new UnitTestFailedWatcher();

  public GenericProtein createProtein() {
    GenericProtein result = new GenericProtein("s" + (elementCounter++));
    result.setHomodimer(12);
    result.addStructuralState(new StructuralState());
    result.setHypothetical(true);

    Residue residue = new Residue();
    result.addResidue(residue);

    residue.setIdModificationResidue("a");
    residue.setName("name");
    residue.setPosition(new Point2D.Double(10, 20));
    residue.setState(ModificationState.DONT_CARE);
    return result;
  }

}
